<?php
/*
 * Copyright (C) 2001-2002 Caldera International, Inc.  All Rights Reserved.
 */

class Help {

	var $id;
	var $page;
	var $valid;

	function Help($id) {
		global $session_lang;

		$this->id = $id;
		$this->valid = false;

		$page = $this->_getHelpPage($session_lang, $id);
		$filename = $this->_getHelpFilePath($page);
		if (is_file($filename)) {
			$this->valid = true;
		} else {
			$page = $this->_getHelpPage('en', $id);
			$filename = $this->_getHelpFilePath($page);
			if (is_file($filename)) {
				$this->valid = true;
			}
		}

		$this->page = '/msghelp/' . $page;

	}

	function _getHelpPage($lang, $id) {
		return $lang . '/' . $this->_map($id);
	}

	function _getHelpFilePath($page) {
		global $_DOCVIEW_ROOT;

		return ereg_replace('#.*$', '', $_DOCVIEW_ROOT . $page);
	}

	function display() {
		if ($this->valid) {

			$this->_display();
		} else {
			$this->_display_invalid();
		}
	}

	function _display() {
		gotoURL($this->page);
	}

	function _display_old() {
		$template = './help/template.html';

		$_HELPTEXT = File::readFile($this->page);
		$html = File::parseFile($template);

		$html = ereg_replace('%%HELPTEXT%%', $_HELPTEXT, $html);

		print($html);
	}

	function _display_invalid() {
		global $HELPPATH;

		$template = './help/template.html';

		$_HELPTEXT = '<h1>' . getIntlMsg('MSG_HELP_NOHELP_HEADING') . '</h1>' .
			'<p>' . getIntlMsg('MSG_HELP_NOHELP_DESC') . '</p>';

		$html = File::parseFile($template);

		$html = ereg_replace('%%HELPTEXT%%', $_HELPTEXT, $html);

		print($html);
	}

	function _map($mapid) {
		global $session_user, $HELP_LOGINMAP, $HELP_USERMAP,
			$HELP_ADMINMAP;

		if (! $session_user) {
			$mapfile .= $HELP_LOGINMAP;
		} elseif (isAdmin()) {
			$mapfile .= $HELP_ADMINMAP;
		} else {
			$mapfile .= $HELP_USERMAP;
		}

		$map = split("\n", File::readFile($mapfile));
		foreach ($map as $i) {
			list($id, $val) = split(':', $i, 2);
			if ($id == $mapid) {
				return $val;
			}
		}

		return '';
	}
	

	/**********************************************************************
	 * class method - docviewURL()
	 **********************************************************************
	 */
	function docviewURL($page) {
		global $_DOCVIEW_BASE, $session_lang;

		// remember we're operating as a class function not
	 	// an instance.
		$file = Help::_getHelpFilePath($session_lang . $page);

		if (is_readable($file)) {
			$url = $_DOCVIEW_BASE . $session_lang . $page;
		} else {
			$url = $_DOCVIEW_BASE . 'en' . $page;
		}

		return $url;
	}
}

?>
