<?php
/*
 * Copyright (C) 2001-2002 Caldera International, Inc.  All Rights Reserved.
 */

class Search {
	var $active;
	var $attr;
	var $value;
	var $op;
	var $id;

	var $listClass;
	var $attrArray;
	var $opArray;

	function Search($varArray, $id) {
		if (! isset($varArray['findText']) ||
		    $varArray['findText'] === ''      ) {
			$this = '';
			return;
		}

		$class = $varArray['listClass'];
		if (class_exists($class)) {
			if (in_array('getsearchattrs', get_class_methods($class))) {
				$foo = create_function('', "return $class::getSearchAttrs();");
				$this->attrArray = $foo();
			}
		} else {
			$this = '';
			return;
		}

		$this->value = $varArray['findText'];
		$this->id = $id;

		if (! isset($varArray['findOp']) || 
		    $varArray['findOp'] === ''        ) {
			$this->op = getIntlMSG('MSG_WHERE_CONTAINS');
		} else {
			$this->op = $varArray['findOp'];
		}

		if (! isset($varArray['findAttr']) ||
		    $varArray['findAttr'] === ''      ) {
			$this->attr = '';
		} else {
			$this->attr = $varArray['findAttr'];
		}

		$this->opArray = $this->getSearchOps();
	}

	function isRequested($varArray) {
		if (isset($varArray['findAttr']) &&
		    isset($varArray['findText']) &&
		    isset($varArray['findOp'])      ) {
			if ($varArray['findAttr'] !== '' &&
		    	    $varArray['findText'] !== '' &&
		   	    $varArray['findOp'] !== ''       ) {
				return true;
			}
		}
		if (isset($varArray['findText']) &&
		    ! isset($varArray['findAttr']) &&
		    ! isset($varArray['findOp']))     {
			if ($varArray['findText'] !== '') {
				return true;
			}
		}
		return false;
	}

	function isActive($id) {
		global $session_searchObj;
		if ($session_searchObj != '') {
			if ($session_searchObj->getId() == $id) {
				return true;
			}
		}
		return false;
	}

	function getActive() {
		global $session_searchObj;
		if ($session_searchObj == '') {
			return '';
		}
		return $session_searchObj;
	}

	function getId() {
		return $this->id;
	}

	function getAttr() {
		return $this->attr;
	}

	function getAttrString() {
		return $this->attrArray[$this->attr];
	}

	function setAttr($value) {
		$this->attr = $value;
	}

	function getValue() {
		return $this->value;
	}

	function setValue($value) {
		$this->value = $value;
	}

	function getOp() {
		return $this->op;
	}

	function getOpString() {
		return $this->opArray[$this->op];
	}

	function setOp($value) {
		$this->op = $value;
	}

	function save() {
		global $session_searchObj;
		
		$session_searchObj = $this;
	}

	function getExpression() {
		switch ($this->op) {
			case 'is':
			case 'is not':
				$retval = '^' . $this->value . '$';
				break;
			case 'starts with':
				$retval = '^' . $this->value;
				break;
			case 'ends with':
				$retval = $this->value . '$';
				break;
			case 'contains':
				$retval = $this->value;
				break;
			default:
				$retval = '^';
				break;
		}

		return $retval;
	}

	function isNegated() {
		if ($this->op == 'is not') return true;

		return false;
	}

	function clear() {
		$GLOBALS['searchObj'] = '';
	}
                                    
	function getSearchOps() {
		$tmp = array(
			'is' => getIntlMsg('MSG_WHERE_IS'),
    			'is not' => getIntlMsg('MSG_WHERE_IS_NOT'),
    			'starts with' => getIntlMsg('MSG_WHERE_STARTS_WITH'),
    			'ends with' => getIntlMsg('MSG_WHERE_ENDS_WITH'),
    			'contains' => getIntlMsg('MSG_WHERE_CONTAINS')
		);

		return $tmp;
	}

	function renderAttrOptions($array) {
		return Search::renderArrayAsOptionList($array);
	}

	function renderOperatorOptions($array) {
		return Search::renderArrayAsOptionList($array);
	}

	function renderArrayAsOptionList($array) {
		$retval = '';
		foreach ($array as $key => $value) {
			$retval .= '<option value="' . escQuote($key) . '">' .
				   $value . '</option>' . "\n";
		}
		return $retval;
	}

}
?>
